﻿using System;
using System.Runtime.Remoting;

namespace BouyomiChanPlugin
{
    public class BouyomiChanPlugin : nwhois.plugin.IPlugin
    {
        private FNF.Utility.BouyomiChanClient bouyomiChanClient = null;
        private nwhois.plugin.IPluginHost host = null;
        private BouyomiChanForm bouyomiChanForm = null;
        private bool enabledTalk = false;
        private bool currentLive = false;
        private string currentLiveId = null;
        private DateTime currentBaseTime;
        private int currentCommentCount;

        public BouyomiChanPlugin()
        {

        }

        public string Name
        {
            get { return "棒読みちゃん"; }
        }

        public string Description
        {
            get { return "コメントを棒読みちゃんが読みます。"; }
        }

        public nwhois.plugin.IPluginHost Host
        {
            get { return host; }
            set { host = value; }
        }

        public bool IsAlive
        {
            get { return true; }
        }

        public void Run()
        {
            if (bouyomiChanForm == null)
            {
                bouyomiChanForm = new BouyomiChanForm();
                bouyomiChanForm.Plugin = this;
            }
            bouyomiChanForm.Show();
        }

        public void OnComment(NicoApi.Chat chat)
        {
            if (EnabledTalk)
                talkBouyomiChan(chat.Message);
        }

        public void OnLiveStart(string liveId, DateTime baseTime, int commentCount)
        {
            currentLive = true;
            currentLiveId = liveId;
            currentBaseTime = baseTime;
            currentCommentCount = commentCount;
            if (bouyomiChanClient == null)
            {
                bouyomiChanClient = new FNF.Utility.BouyomiChanClient();
            }
        }

        public void OnLiveStop()
        {
            currentLive = false;
            if (bouyomiChanClient != null)
            {
                bouyomiChanClient.Dispose();
                bouyomiChanClient = null;
            }
        }

        public bool IsLive
        {
            get { return currentLive; }
        }

        public bool EnabledTalk
        {
            get { return enabledTalk && (bouyomiChanClient != null); }
            set { enabledTalk = value; }
        }

        private bool talkBouyomiChan(string talk)
        {
            bool result = false;
            try
            {
                if (bouyomiChanClient != null)
                {
                    bouyomiChanClient.AddTalkTask(talk);
                    result = true;
                }
            }
            catch { }
            return result;
        }
    }
}
